--- php-8.4.18/ext/opcache/jit/ir/ir_gcm.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_gcm.c	2026-04-01 04:35:36.009619069 +0000
@@ -262,7 +262,7 @@
 #endif
 
 	/* 1.2. Iteratively check the predecessors of already found TOTALLY_USEFUL blocks and
-	 *      add them into TOTALLY_USEFUL set if all of their sucessors are already there.
+	 *      add them into TOTALLY_USEFUL set if all of their successors are already there.
 	 */
 	IR_SPARSE_SET_FOREACH(&data->totally_useful, i) {
 		_push_predecessors(ctx, &ctx->cfg_blocks[i], data);
@@ -788,7 +788,7 @@
 
 IR_ALWAYS_INLINE bool ir_is_good_bb_order(ir_ctx *ctx, uint32_t b, ir_block *bb, ir_ref start)
 {
-	ir_insn	*insn = &ctx->ir_base[start];
+	ir_insn *insn = &ctx->ir_base[start];
 	uint32_t n = insn->inputs_count;
 	ir_ref *p = insn->ops + 1;
 
@@ -842,6 +842,7 @@
 	xlat = ir_mem_malloc(count * sizeof(uint32_t));
 	ir_worklist_init(&worklist, count);
 	ir_worklist_push(&worklist, 1);
+	/* Schedule blocks bottom-up. Place block only after all its successurs (except back-edges) are placed. */
 	while (ir_worklist_len(&worklist) != 0) {
 next:
 		b = ir_worklist_peek(&worklist);
@@ -849,7 +850,14 @@
 		n = bb->successors_count;
 		if (n == 1) {
 			succ = ctx->cfg_edges[bb->successors];
-			if (ir_worklist_push(&worklist, succ)) {
+			if (ir_bitset_in(worklist.visited, succ)) {
+				/* already processed */
+			} else if ((ctx->cfg_blocks[succ].flags & IR_BB_IRREDUCIBLE_LOOP)
+					&& ((ctx->cfg_blocks[b].flags & IR_BB_LOOP_HEADER) ?
+						(ctx->cfg_blocks[succ].loop_header != b) :
+						(ctx->cfg_blocks[succ].loop_header != ctx->cfg_blocks[b].loop_header))) {
+				/* "side" entry of irreducible loop (ignore) */
+			} else if (ir_worklist_push(&worklist, succ)) {
 				goto next;
 			}
 		} else if (n > 1) {
@@ -862,12 +870,11 @@
 				succ = *q;
 				if (ir_bitset_in(worklist.visited, succ)) {
 					/* already processed */
-				} else if ((ctx->cfg_blocks[succ].flags & IR_BB_LOOP_HEADER)
-				  && (succ == b || ctx->cfg_blocks[b].loop_header == succ)) {
-					/* back-edge of reducible loop */
 				} else if ((ctx->cfg_blocks[succ].flags & IR_BB_IRREDUCIBLE_LOOP)
-				  && (ctx->cfg_blocks[succ].loop_header == ctx->cfg_blocks[b].loop_header)) {
-					/* closing edge of irreducible loop */
+						&& ((ctx->cfg_blocks[b].flags & IR_BB_LOOP_HEADER) ?
+							(ctx->cfg_blocks[succ].loop_header != b) :
+							(ctx->cfg_blocks[succ].loop_header != ctx->cfg_blocks[b].loop_header))) {
+					/* "side" entry of irreducible loop (ignore) */
 				} else if (!best) {
 					best = succ;
 					best_loop_depth = ctx->cfg_blocks[best].loop_depth;
@@ -883,6 +890,8 @@
 				goto next;
 			}
 		}
+
+		/* All successors of "b" are placed. Now we can place "b" itself. */
 		ir_worklist_pop(&worklist);
 		count--;
 		new_blocks[count] = *bb;
@@ -924,25 +933,120 @@
 	ctx->cfg_blocks = new_blocks;
 }
 
+#if IR_DEBUG
+static void ir_schedule_print_list(const ir_ctx *ctx, uint32_t b, const ir_ref *_next,
+                                   ir_ref start, ir_ref end, const char *label)
+{
+	ir_ref ref;
+
+	fprintf(stderr, "  %s [%d", label, start);
+	ref = _next[start];
+	while (ref != end) {
+		fprintf(stderr, ",%d", ref);
+		ref = _next[ref];
+	}
+	fprintf(stderr, ",%d]\n", ref);
+}
+#endif
+
+/* Simple Stable Topological Sort */
+static void ir_schedule_topsort(const ir_ctx *ctx, uint32_t b, const ir_block *bb,
+                                ir_ref *_xlat, ir_ref *_next, ir_ref *_prev,
+                                ir_ref ref, ir_ref end,
+                                ir_ref *insns_count, ir_ref *consts_count)
+{
+	ir_ref i = ref;
+	const ir_insn *insn;
+
+	if (bb->successors_count > 1) {
+		ir_ref input, j = bb->end;
+		ir_insn *end = &ctx->ir_base[j];
+
+		if (end->op == IR_IF) {
+			/* Move condition closer to IF */
+			input = end->op2;
+			if (input > 0
+			 && ctx->cfg_map[input] == b
+			 && !_xlat[input]
+			 && _prev[j] != input
+			 && (!(ir_op_flags[ctx->ir_base[input].op] & IR_OP_FLAG_CONTROL) || end->op1 == input)) {
+				if (input == i) {
+					i = _next[i];
+					insn = &ctx->ir_base[i];
+				}
+				/* remove "input" */
+				_prev[_next[input]] = _prev[input];
+				_next[_prev[input]] = _next[input];
+				/* insert before "j" */
+				_prev[input] = _prev[j];
+				_next[input] = j;
+				_next[_prev[j]] = input;
+				_prev[j] = input;
+			}
+		}
+	}
+
+	while (i != end) {
+		ir_ref n, j, input;
+		const ir_ref *p;
+
+restart:
+		IR_ASSERT(ctx->cfg_map[i] == b);
+		insn = &ctx->ir_base[i];
+		n = insn->inputs_count;
+		for (j = n, p = insn->ops + 1; j > 0; p++, j--) {
+			input = *p;
+			if (!_xlat[input]) {
+				/* input is not scheduled yet */
+				if (input > 0) {
+					if (ctx->cfg_map[input] == b) {
+						/* "input" should be before "i" to satisfy dependency */
+#ifdef IR_DEBUG
+						if (ctx->flags & IR_DEBUG_SCHEDULE) {
+							fprintf(stderr, "Wrong dependency %d:%d -> %d\n", b, input, i);
+						}
+#endif
+						/* remove "input" */
+						_prev[_next[input]] = _prev[input];
+						_next[_prev[input]] = _next[input];
+						/* insert before "i" */
+						_prev[input] = _prev[i];
+						_next[input] = i;
+						_next[_prev[i]] = input;
+						_prev[i] = input;
+						/* restart from "input" */
+						i = input;
+						goto restart;
+					}
+				} else if (input < IR_TRUE) {
+					*consts_count += ir_count_constant(_xlat, input);
+				}
+			}
+		}
+
+		_xlat[i] = *insns_count;
+		*insns_count += ir_insn_inputs_to_len(n);
+		IR_ASSERT(_next[i] != IR_UNUSED);
+		i = _next[i];
+	}
+}
+
 int ir_schedule(ir_ctx *ctx)
 {
-	ir_ctx new_ctx;
 	ir_ref i, j, k, n, *p, *q, ref, new_ref, prev_ref, insns_count, consts_count, use_edges_count;
 	ir_ref *_xlat;
 	ir_ref *edges;
 	ir_ref prev_b_end;
 	uint32_t b;
-	uint32_t *_blocks = ctx->cfg_map;
 	ir_ref *_next = ir_mem_malloc(ctx->insns_count * sizeof(ir_ref));
 	ir_ref *_prev = ir_mem_malloc(ctx->insns_count * sizeof(ir_ref));
 	ir_block *bb;
-	ir_insn *insn, *new_insn;
+	ir_insn *insn, *new_insn, *base;
 	ir_use_list *lists, *use_list, *new_list;
 	bool bad_bb_order = 0;
 
-
 	/* Create a double-linked list of nodes ordered by BB, respecting BB->start and BB->end */
-	IR_ASSERT(_blocks[1] == 1);
+	IR_ASSERT(ctx->cfg_map[1] == 1);
 
 	/* link BB boundaries */
 	_prev[1] = 0;
@@ -950,30 +1054,34 @@
 	_next[1] = prev_b_end;
 	_prev[prev_b_end] = 1;
 	for (b = 2, bb = ctx->cfg_blocks + 2; b <= ctx->cfg_blocks_count; b++, bb++) {
-		_next[prev_b_end] = bb->start;
-		_prev[bb->start] = prev_b_end;
-		_next[bb->start] = bb->end;
-		_prev[bb->end] = bb->start;
-		prev_b_end = bb->end;
-		if (!ir_is_good_bb_order(ctx, b, bb, bb->start)) {
+		ir_ref start = bb->start;
+		ir_ref end = bb->end;
+		_next[prev_b_end] = start;
+		_prev[start] = prev_b_end;
+		_next[start] = end;
+		_prev[end] = start;
+		prev_b_end = end;
+		if (!ir_is_good_bb_order(ctx, b, bb, start)) {
 			bad_bb_order = 1;
 		}
 	}
 	_next[prev_b_end] = 0;
 
 	/* insert intermediate BB nodes */
-	for (i = 2, j = 1; i < ctx->insns_count; i++) {
-		b = _blocks[i];
+	use_edges_count = ctx->use_lists[1].count;
+	for (i = 2, use_list = &ctx->use_lists[i]; i < ctx->insns_count; use_list++, i++) {
+		b = ctx->cfg_map[i];
 		if (!b) continue;
+		use_edges_count += use_list->count;
 		bb = &ctx->cfg_blocks[b];
 		if (i != bb->start && i != bb->end) {
 			/* insert before "end" */
-			ir_ref n = bb->end;
-			ir_ref p = _prev[n];
-			_prev[i] = p;
-			_next[i] = n;
-			_next[p] = i;
-			_prev[n] = i;
+			ir_ref next = bb->end;
+			ir_ref prev = _prev[next];
+			_prev[i] = prev;
+			_next[i] = next;
+			_next[prev] = i;
+			_prev[next] = i;
 		}
 	}
 
@@ -981,15 +1089,6 @@
 		ir_fix_bb_order(ctx, _prev, _next);
 	}
 
-#ifdef IR_DEBUG
-	if (ctx->flags & IR_DEBUG_SCHEDULE) {
-		fprintf(stderr, "Before Schedule\n");
-		for (i = 1; i != 0; i = _next[i]) {
-			fprintf(stderr, "%d -> %d\n", i, _blocks[i]);
-		}
-	}
-#endif
-
 	_xlat = ir_mem_calloc((ctx->consts_count + ctx->insns_count), sizeof(ir_ref));
 	_xlat += ctx->consts_count;
 	_xlat[IR_TRUE] = IR_TRUE;
@@ -999,10 +1098,17 @@
 	insns_count = 1;
 	consts_count = -(IR_TRUE - 1);
 
-	/* Topological sort according dependencies inside each basic block */
+	/* Schedule instructions inside each BB (now just topological sort according to dependencies) */
 	for (b = 1, bb = ctx->cfg_blocks + 1; b <= ctx->cfg_blocks_count; b++, bb++) {
 		ir_ref start;
 
+#ifdef IR_DEBUG
+		if (ctx->flags & IR_DEBUG_SCHEDULE) {
+			fprintf(stderr, "BB%d\n", b);
+			ir_schedule_print_list(ctx, b, _next, bb->start, bb->end, "INITIAL");
+		}
+#endif
+
 		IR_ASSERT(!(bb->flags & IR_BB_UNREACHABLE));
 		/* Schedule BB start */
 		start = i = bb->start;
@@ -1062,8 +1168,8 @@
 				for (p = &ctx->use_edges[use_list->refs]; count > 0; p++, count--) {
 					ir_ref use = *p;
 					ir_insn *use_insn = &ctx->ir_base[use];
-					if (!_xlat[use] && (_blocks[use] || use_insn->op == IR_PARAM)) {
-						IR_ASSERT(_blocks[use] == b || use_insn->op == IR_PARAM);
+					if (!_xlat[use] && ctx->cfg_map[use]) {
+						IR_ASSERT(ctx->cfg_map[use] == b);
 						if (use_insn->op == IR_PARAM
 						 || use_insn->op == IR_VAR
 						 || use_insn->op == IR_PI
@@ -1100,76 +1206,20 @@
 				insn = &ctx->ir_base[i];
 			}
 		}
-		if (bb->successors_count > 1) {
-			ir_ref input, j = bb->end;
-			ir_insn *end = &ctx->ir_base[j];
-
-			if (end->op == IR_IF) {
-				/* Move condition closer to IF */
-				input = end->op2;
-				if (input > 0
-				 && _blocks[input] == b
-				 && !_xlat[input]
-				 && _prev[j] != input
-				 && (!(ir_op_flags[ctx->ir_base[input].op] & IR_OP_FLAG_CONTROL) || end->op1 == input)) {
-					if (input == i) {
-						i = _next[i];
-						insn = &ctx->ir_base[i];
-					}
-					/* remove "input" */
-					_prev[_next[input]] = _prev[input];
-					_next[_prev[input]] = _next[input];
-					/* insert before "j" */
-					_prev[input] = _prev[j];
-					_next[input] = j;
-					_next[_prev[j]] = input;
-					_prev[j] = input;
-				}
-			}
+
+		if (i != bb->end) {
+			ir_schedule_topsort(ctx, b, bb, _xlat, _next, _prev, i, bb->end, &insns_count, &consts_count);
 		}
-		while (i != bb->end) {
-			ir_ref n, j, *p, input;
 
-restart:
-			IR_ASSERT(_blocks[i] == b);
-			n = insn->inputs_count;
-			for (j = n, p = insn->ops + 1; j > 0; p++, j--) {
-				input = *p;
-				if (!_xlat[input]) {
-					/* input is not scheduled yet */
-					if (input > 0) {
-						if (_blocks[input] == b) {
-							/* "input" should be before "i" to satisfy dependency */
 #ifdef IR_DEBUG
-							if (ctx->flags & IR_DEBUG_SCHEDULE) {
-								fprintf(stderr, "Wrong dependency %d:%d -> %d\n", b, input, i);
-							}
-#endif
-							/* remove "input" */
-							_prev[_next[input]] = _prev[input];
-							_next[_prev[input]] = _next[input];
-							/* insert before "i" */
-							_prev[input] = _prev[i];
-							_next[input] = i;
-							_next[_prev[i]] = input;
-							_prev[i] = input;
-							/* restart from "input" */
-							i = input;
-							insn = &ctx->ir_base[i];
-							goto restart;
-						}
-					} else if (input < IR_TRUE) {
-						consts_count += ir_count_constant(_xlat, input);
-					}
-				}
-			}
-			_xlat[i] = insns_count;
-			insns_count += ir_insn_inputs_to_len(n);
-			IR_ASSERT(_next[i] != IR_UNUSED);
-			i = _next[i];
-			insn = &ctx->ir_base[i];
+		if (ctx->flags & IR_DEBUG_SCHEDULE) {
+			ir_schedule_print_list(ctx, b, _next, start, bb->end, "  FINAL");
 		}
+#endif
+
 		/* Schedule BB end */
+		i = bb->end;
+		insn = &ctx->ir_base[i];
 		_xlat[i] = bb->end = insns_count;
 		insns_count++;
 		if (IR_INPUT_EDGES_COUNT(ir_op_flags[insn->op]) == 2) {
@@ -1179,15 +1229,6 @@
 		}
 	}
 
-#ifdef IR_DEBUG
-	if (ctx->flags & IR_DEBUG_SCHEDULE) {
-		fprintf(stderr, "After Schedule\n");
-		for (i = 1; i != 0; i = _next[i]) {
-			fprintf(stderr, "%d -> %d (%d)\n", i, _blocks[i], _xlat[i]);
-		}
-	}
-#endif
-
 #if 1
 	/* Check if scheduling didn't make any modifications */
 	if (consts_count == ctx->consts_count && insns_count == ctx->insns_count) {
@@ -1215,113 +1256,55 @@
 
 	ir_mem_free(_prev);
 
-	ir_init(&new_ctx, ctx->flags, consts_count, insns_count);
-	new_ctx.insns_count = insns_count;
-	new_ctx.flags2 = ctx->flags2;
-	new_ctx.ret_type = ctx->ret_type;
-	new_ctx.value_params = ctx->value_params;
-	new_ctx.mflags = ctx->mflags;
-	new_ctx.spill_base = ctx->spill_base;
-	new_ctx.fixed_stack_red_zone = ctx->fixed_stack_red_zone;
-	new_ctx.fixed_stack_frame_size = ctx->fixed_stack_frame_size;
-	new_ctx.fixed_call_stack_size = ctx->fixed_call_stack_size;
-	new_ctx.fixed_regset = ctx->fixed_regset;
-	new_ctx.fixed_save_regset = ctx->fixed_save_regset;
-	new_ctx.entries_count = ctx->entries_count;
-#if defined(IR_TARGET_AARCH64)
-	new_ctx.deoptimization_exits = ctx->deoptimization_exits;
-	new_ctx.get_exit_addr = ctx->get_exit_addr;
-	new_ctx.get_veneer = ctx->get_veneer;
-	new_ctx.set_veneer = ctx->set_veneer;
-#endif
-	new_ctx.loader = ctx->loader;
+	uint32_t *map = ir_mem_calloc(insns_count, sizeof(uint32_t));
+	_prev = ir_mem_malloc(insns_count * sizeof(ir_ref));
+	lists = ir_mem_malloc(insns_count * sizeof(ir_use_list));
+	ir_ref *use_edges = edges = ir_mem_malloc(use_edges_count * sizeof(ir_ref));
+	base = ir_mem_malloc((consts_count + insns_count) * sizeof(ir_insn));
+	base += consts_count;
 
 	/* Copy constants */
-	if (consts_count == ctx->consts_count) {
-		new_ctx.consts_count = consts_count;
-		ref = 1 - consts_count;
-		insn = &ctx->ir_base[ref];
-		new_insn = &new_ctx.ir_base[ref];
-
-		memcpy(new_insn, insn, sizeof(ir_insn) * (IR_TRUE - ref));
-		if (ctx->strtab.data) {
-			while (ref != IR_TRUE) {
-				if (new_insn->op == IR_FUNC_ADDR) {
-					if (new_insn->proto) {
-						size_t len;
-						const char *proto = ir_get_strl(ctx, new_insn->proto, &len);
-						new_insn->proto = ir_strl(&new_ctx, proto, len);
-					}
-				} else if (new_insn->op == IR_FUNC) {
-					size_t len;
-					const char *name = ir_get_strl(ctx, new_insn->val.name, &len);
-					new_insn->val.u64 = ir_strl(&new_ctx, name, len);
-					if (new_insn->proto) {
-						const char *proto = ir_get_strl(ctx, new_insn->proto, &len);
-						new_insn->proto = ir_strl(&new_ctx, proto, len);
-					}
-				} else if (new_insn->op == IR_SYM || new_insn->op == IR_STR || new_insn->op == IR_LABEL) {
-					size_t len;
-					const char *str = ir_get_strl(ctx, new_insn->val.name, &len);
-					new_insn->val.u64 = ir_strl(&new_ctx, str, len);
-				}
-				new_insn++;
-				ref++;
-			}
+	if (ctx->consts_count == consts_count) {
+		memcpy(base - consts_count + 1, ctx->ir_base - consts_count + 1, sizeof(ir_insn) * consts_count);
+		for (j = -consts_count + 1; j < IR_TRUE; j++) {
+			_xlat[j] = j;
 		}
 	} else {
-		new_ref = -new_ctx.consts_count;
-		new_insn = &new_ctx.ir_base[new_ref];
-		for (ref = IR_TRUE - 1, insn = &ctx->ir_base[ref]; ref > -ctx->consts_count; insn--, ref--) {
-			if (!_xlat[ref]) {
-				continue;
-			}
-			new_insn->optx = insn->optx;
-			new_insn->prev_const = 0;
-			if (insn->op == IR_FUNC_ADDR) {
-				new_insn->val.u64 = insn->val.u64;
-				if (insn->proto) {
-					size_t len;
-					const char *proto = ir_get_strl(ctx, insn->proto, &len);
-					new_insn->proto = ir_strl(&new_ctx, proto, len);
-				} else {
-					new_insn->proto = 0;
-				}
-			} else if (insn->op == IR_FUNC) {
-				size_t len;
-				const char *name = ir_get_strl(ctx, insn->val.name, &len);
-				new_insn->val.u64 = ir_strl(&new_ctx, name, len);
-				if (insn->proto) {
-					const char *proto = ir_get_strl(ctx, insn->proto, &len);
-					new_insn->proto = ir_strl(&new_ctx, proto, len);
-				} else {
-					new_insn->proto = 0;
-				}
-			} else if (insn->op == IR_SYM || insn->op == IR_STR || insn->op == IR_LABEL) {
-				size_t len;
-				const char *str = ir_get_strl(ctx, insn->val.name, &len);
-				new_insn->val.u64 = ir_strl(&new_ctx, str, len);
-			} else {
-				new_insn->val.u64 = insn->val.u64;
-			}
-			_xlat[ref] = new_ref;
-			new_ref--;
-			new_insn--;
-		}
-		new_ctx.consts_count = -new_ref;
-	}
+		ir_insn *src = ctx->ir_base - ctx->consts_count + 1;
+		ir_insn *dst = base - consts_count + 1;
 
-	new_ctx.cfg_map = ir_mem_calloc(ctx->insns_count, sizeof(uint32_t));
-	new_ctx.prev_ref = _prev = ir_mem_malloc(insns_count * sizeof(ir_ref));
-	new_ctx.use_lists = lists = ir_mem_malloc(insns_count * sizeof(ir_use_list));
-	new_ctx.use_edges = edges = ir_mem_malloc(ctx->use_edges_count * sizeof(ir_ref));
+		i = -ctx->consts_count + 1;
+		j = -consts_count + 1;
+		while (i < IR_TRUE) {
+			if (_xlat[i]) {
+				*dst = *src;
+				dst->prev_const = 0;
+				_xlat[i] = j;
+				dst++;
+				j++;
+			}
+			src++;
+			i++;
+		}
+		IR_ASSERT(j == IR_TRUE);
+		base[IR_TRUE].optx = IR_OPT(IR_C_BOOL, IR_BOOL);
+		base[IR_TRUE].val.u64 = 1;
+		base[IR_FALSE].optx = IR_OPT(IR_C_BOOL, IR_BOOL);
+		base[IR_FALSE].val.u64 = 0;
+		base[IR_NULL].optx = IR_OPT(IR_C_ADDR, IR_ADDR);
+		base[IR_NULL].val.u64 = 0;
+		MAKE_NOP(&base[IR_UNUSED]);
+	}
 
 	/* Copy instructions, use lists and use edges */
+#ifdef IR_DEBUG
+	ir_ref orig_use_edges_count = use_edges_count;
+#endif
 	prev_ref = 0;
 	use_edges_count = 0;
 	for (i = 1; i != 0; i = _next[i]) {
 		new_ref = _xlat[i];
-		new_ctx.cfg_map[new_ref] = _blocks[i];
+		map[new_ref] = ctx->cfg_map[i];
 		_prev[new_ref] = prev_ref;
 		prev_ref = new_ref;
 
@@ -1330,7 +1313,7 @@
 		k = 0;
 		if (n == 1) {
 			ref = ctx->use_edges[use_list->refs];
-			if (_xlat[ref]) {
+			if (EXPECTED(_xlat[ref])) {
 				*edges = _xlat[ref];
 				edges++;
 				k = 1;
@@ -1339,7 +1322,7 @@
 			p = &ctx->use_edges[use_list->refs];
 			while (n--) {
 				ref = *p;
-				if (_xlat[ref]) {
+				if (EXPECTED(_xlat[ref])) {
 					*edges = _xlat[ref];
 					edges++;
 					k++;
@@ -1353,7 +1336,7 @@
 		new_list->count = k;
 
 		insn = &ctx->ir_base[i];
-		new_insn = &new_ctx.ir_base[new_ref];
+		new_insn = &base[new_ref];
 
 		new_insn->optx = insn->optx;
 		n = new_insn->inputs_count;
@@ -1365,11 +1348,7 @@
 				break;
 			case 1:
 				new_insn->op1 = _xlat[insn->op1];
-				if (new_insn->op == IR_PARAM || new_insn->op == IR_VAR || new_insn->op == IR_PROTO) {
-					size_t len;
-					const char *str = ir_get_strl(ctx, insn->op2, &len);
-					new_insn->op2 = ir_strl(&new_ctx, str, len);
-				} else if (new_insn->op == IR_BEGIN && insn->op2) {
+				if (new_insn->op == IR_BEGIN && insn->op2) {
 					new_insn->op2 = _xlat[insn->op2];
 				} else {
 					new_insn->op2 = insn->op2;
@@ -1428,12 +1407,12 @@
 	}
 
 	/* Update list of terminators (IR_OPND_CONTROL_REF) */
-	insn = &new_ctx.ir_base[1];
+	insn = &base[1];
 	ref = insn->op1;
 	if (ref) {
 		insn->op1 = ref = _xlat[ref];
 		while (1) {
-			insn = &new_ctx.ir_base[ref];
+			insn = &base[ref];
 			ref = insn->op3;
 			if (!ref) {
 				break;
@@ -1442,36 +1421,33 @@
 		}
 	}
 
-	IR_ASSERT(ctx->use_edges_count >= use_edges_count);
-	new_ctx.use_edges_count = use_edges_count;
-	new_ctx.use_edges = ir_mem_realloc(new_ctx.use_edges, use_edges_count * sizeof(ir_ref));
-
 	if (ctx->binding) {
 		ir_xlat_binding(ctx, _xlat);
-		new_ctx.binding = ctx->binding;
-		ctx->binding = NULL;
 	}
 
 	_xlat -= ctx->consts_count;
 	ir_mem_free(_xlat);
+	ir_mem_free(_next);
 
-	new_ctx.cfg_blocks_count = ctx->cfg_blocks_count;
-	new_ctx.cfg_edges_count = ctx->cfg_edges_count;
-	new_ctx.cfg_blocks = ctx->cfg_blocks;
-	new_ctx.cfg_edges = ctx->cfg_edges;
-	ctx->cfg_blocks = NULL;
-	ctx->cfg_edges = NULL;
-	ctx->value_params = NULL;
-	ir_code_buffer *saved_code_buffer = ctx->code_buffer;
-
-	ir_free(ctx);
-	IR_ASSERT(new_ctx.consts_count == new_ctx.consts_limit);
-	IR_ASSERT(new_ctx.insns_count == new_ctx.insns_limit);
-	memcpy(ctx, &new_ctx, sizeof(ir_ctx));
-	ctx->code_buffer = saved_code_buffer;
-	ctx->flags2 |= IR_LINEAR;
+	/* Switch to new IR buffer */
+	ir_mem_free(ctx->ir_base - ctx->consts_limit);
+	ctx->ir_base = base;
+	ctx->insns_count = ctx->insns_limit = insns_count;
+	ctx->consts_count = ctx->consts_limit = consts_count;
+
+	ir_mem_free(ctx->use_lists);
+	ir_mem_free(ctx->use_edges);
+	IR_ASSERT(orig_use_edges_count >= use_edges_count);
+	ctx->use_lists = lists;
+	ctx->use_edges = use_edges;
+	ctx->use_edges_count = use_edges_count;
 
-	ir_mem_free(_next);
+	ir_mem_free(ctx->cfg_map);
+	ctx->cfg_map = map;
+
+	ctx->prev_ref = _prev;
+
+	ctx->flags2 |= IR_LINEAR;
 
 	return 1;
 }
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_gdb.c php-8.4.20RC1/ext/opcache/jit/ir/ir_gdb.c
--- php-8.4.18/ext/opcache/jit/ir/ir_gdb.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_gdb.c	2026-04-01 04:35:36.009855365 +0000
@@ -7,6 +7,10 @@
  * Based on Mike Pall's implementation of GDB interface for LuaJIT.
  */
 
+#ifndef _GNU_SOURCE
+# define _GNU_SOURCE
+#endif
+
 #include <stddef.h>
 #include <stdlib.h>
 #include <unistd.h>
@@ -517,6 +521,8 @@
 static bool ir_gdb_register_code(const void *object, size_t size)
 {
 	ir_gdbjit_code_entry *entry;
+	ir_elf_header *elf_header;
+	ir_elf_sectheader *elf_section, *elf_section_end;
 
 	entry = malloc(sizeof(ir_gdbjit_code_entry) + size);
 	if (entry == NULL) {
@@ -528,6 +534,17 @@
 
 	memcpy((char *)entry->symfile_addr, object, size);
 
+	elf_header = (ir_elf_header*)entry->symfile_addr;
+	elf_section = (ir_elf_sectheader*)(entry->symfile_addr + elf_header->shofs);
+	elf_section_end = (ir_elf_sectheader*)((char*)elf_section + (elf_header->shentsize * elf_header->shnum));
+
+	while (elf_section < elf_section_end) {
+		if ((elf_section->flags & ELFSECT_FLAGS_ALLOC) && elf_section->addr == 0) {
+			elf_section->addr = (uintptr_t)(entry->symfile_addr + elf_section->ofs);
+		}
+		elf_section = (ir_elf_sectheader*)((char*)elf_section + elf_header->shentsize);
+	}
+
 	entry->prev_entry = NULL;
 	entry->next_entry = __jit_debug_descriptor.first_entry;
 
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir.h php-8.4.20RC1/ext/opcache/jit/ir/ir.h
--- php-8.4.18/ext/opcache/jit/ir/ir.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir.h	2026-04-01 04:35:36.008176533 +0000
@@ -569,8 +569,6 @@
 #define IR_OPT_CFG             (1<<21) /* merge BBs, by remove END->BEGIN nodes during CFG construction */
 #define IR_OPT_MEM2SSA         (1<<22)
 #define IR_OPT_CODEGEN         (1<<23)
-#define IR_GEN_NATIVE          (1<<24)
-#define IR_GEN_CODE            (1<<25)
 
 /* debug related */
 #ifdef IR_DEBUG
@@ -771,7 +769,7 @@
 
 ir_ref ir_emit_N(ir_ctx *ctx, uint32_t opt, int32_t count);
 void   ir_set_op(ir_ctx *ctx, ir_ref ref, int32_t n, ir_ref val);
-ir_ref ir_get_op(ir_ctx *ctx, ir_ref ref, int32_t n);
+ir_ref ir_get_op(const ir_ctx *ctx, ir_ref ref, int32_t n);
 
 IR_ALWAYS_INLINE void ir_set_op1(ir_ctx *ctx, ir_ref ref, ir_ref val)
 {
@@ -865,13 +863,13 @@
 int ir_regs_number(void);
 bool ir_reg_is_int(int32_t reg);
 const char *ir_reg_name(int8_t reg, ir_type type);
-int32_t ir_get_spill_slot_offset(ir_ctx *ctx, ir_ref ref);
+int32_t ir_get_spill_slot_offset(const ir_ctx *ctx, ir_ref ref);
 
 /* Target CPU instruction selection and code generation (see ir_x86.c) */
 int ir_match(ir_ctx *ctx);
 void *ir_emit_code(ir_ctx *ctx, size_t *size);
 
-bool ir_needs_thunk(ir_code_buffer *code_buffer, void *addr);
+bool ir_needs_thunk(const ir_code_buffer *code_buffer, void *addr);
 void *ir_emit_thunk(ir_code_buffer *code_buffer, void *addr, size_t *size_ptr);
 void ir_fix_thunk(void *thunk_entry, void *addr);
 
@@ -947,13 +945,14 @@
 #define IR_SAVE_REGS       (1<<4) /* add info about selected registers */
 #define IR_SAVE_SAFE_NAMES (1<<5) /* add '@' prefix to symbol names */
 
+void ir_print_func_proto(const ir_ctx *ctx, const char *name, bool prefix, FILE *f);
 void ir_print_proto(const ir_ctx *ctx, ir_ref proto, FILE *f);
 void ir_print_proto_ex(uint8_t flags, ir_type ret_type, uint32_t params_count, const uint8_t *param_types, FILE *f);
 void ir_save(const ir_ctx *ctx, uint32_t save_flags, FILE *f);
 
 /* IR debug dump API (implementation in ir_dump.c) */
 void ir_dump(const ir_ctx *ctx, FILE *f);
-void ir_dump_dot(const ir_ctx *ctx, const char *name, FILE *f);
+void ir_dump_dot(const ir_ctx *ctx, const char *name, const char *comments, FILE *f);
 void ir_dump_use_lists(const ir_ctx *ctx, FILE *f);
 void ir_dump_cfg(ir_ctx *ctx, FILE *f);
 void ir_dump_cfg_map(const ir_ctx *ctx, FILE *f);
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_perf.c php-8.4.20RC1/ext/opcache/jit/ir/ir_perf.c
--- php-8.4.18/ext/opcache/jit/ir/ir_perf.c	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_perf.c	2026-04-01 04:35:36.009948752 +0000
@@ -14,6 +14,10 @@
  * perf report -i perf.data.jitted
  */
 
+#ifndef _GNU_SOURCE
+# define _GNU_SOURCE
+#endif
+
 #include <stdio.h>
 #include <unistd.h>
 #include <time.h>
@@ -26,7 +30,7 @@
 
 #if defined(__linux__)
 #include <sys/syscall.h>
-#elif defined(__darwin__)
+#elif defined(__APPLE__)
 # include <pthread.h>
 #elif defined(__FreeBSD__)
 # include <sys/thr.h>
@@ -211,7 +215,7 @@
 		uint32_t thread_id = 0;
 #if defined(__linux__)
 		thread_id = syscall(SYS_gettid);
-#elif defined(__darwin__)
+#elif defined(__APPLE__)
 		uint64_t thread_id_u64;
 		pthread_threadid_np(NULL, &thread_id_u64);
 		thread_id = (uint32_t) thread_id_u64;
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_private.h php-8.4.20RC1/ext/opcache/jit/ir/ir_private.h
--- php-8.4.18/ext/opcache/jit/ir/ir_private.h	2026-02-10 17:48:03.000000000 +0000
+++ php-8.4.20RC1/ext/opcache/jit/ir/ir_private.h	2026-04-01 04:35:36.010041096 +0000
@@ -908,7 +908,7 @@
 	return 0;
 }
 
-IR_ALWAYS_INLINE bool ir_ref_is_true(ir_ctx *ctx, ir_ref ref)
+IR_ALWAYS_INLINE bool ir_ref_is_true(const ir_ctx *ctx, ir_ref ref)
 {
 	if (ref == IR_TRUE) {
 		return 1;
@@ -1096,6 +1096,7 @@
 void ir_update_op(ir_ctx *ctx, ir_ref ref, uint32_t idx, ir_ref new_val);
 
 /*** Iterative Optimization ***/
+void ir_iter_add_uses(ir_ctx *ctx, ir_ref ref, ir_bitqueue *worklist);
 void ir_iter_replace(ir_ctx *ctx, ir_ref ref, ir_ref new_ref, ir_bitqueue *worklist);
 void ir_iter_update_op(ir_ctx *ctx, ir_ref ref, uint32_t idx, ir_ref new_val, ir_bitqueue *worklist);
 void ir_iter_opt(ir_ctx *ctx, ir_bitqueue *worklist);
@@ -1144,12 +1145,15 @@
 	};
 	union {
 		uint32_t dom_depth;      /* depth from the root of the dominators tree */
-		uint32_t postnum;        /* used temporary during tree constructon     */
+		uint32_t postnum;        /* used temporary for iterative Post Ordering */
 	};
 	uint32_t     dom_child;      /* first dominated blocks                     */
 	uint32_t     dom_next_child; /* next dominated block (linked list)         */
 	uint32_t     loop_header;
-	uint32_t     loop_depth;
+	union {
+		uint32_t loop_depth;
+		uint32_t next_succ;      /* used temporary for iterative Post Ordering */
+	};
 };
 
 void ir_build_prev_refs(ir_ctx *ctx);
@@ -1179,16 +1183,17 @@
 	IR_FOLD_DO_CONST
 } ir_fold_action;
 
-ir_ref ir_folding(ir_ctx *ctx, uint32_t opt, ir_ref op1, ir_ref op2, ir_ref op3, ir_insn *op1_insn, ir_insn *op2_insn, ir_insn *op3_insn);
+ir_ref ir_folding(ir_ctx *ctx, uint32_t opt, ir_ref op1, ir_ref op2, ir_ref op3,
+                  const ir_insn *op1_insn, const ir_insn *op2_insn, const ir_insn *op3_insn);
 
 /*** Alias Analyzes (see ir.c) ***/
-ir_ref ir_find_aliasing_load(ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref addr);
-ir_ref ir_find_aliasing_vload(ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref var);
+ir_ref ir_find_aliasing_load(const ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref addr);
+ir_ref ir_find_aliasing_vload(const ir_ctx *ctx, ir_ref ref, ir_type type, ir_ref var);
 ir_ref ir_find_aliasing_store(ir_ctx *ctx, ir_ref ref, ir_ref addr, ir_ref val);
 ir_ref ir_find_aliasing_vstore(ir_ctx *ctx, ir_ref ref, ir_ref addr, ir_ref val);
 
 /*** Predicates (see ir.c) ***/
-ir_ref ir_check_dominating_predicates(ir_ctx *ctx, ir_ref ref, ir_ref condition);
+ir_ref ir_check_dominating_predicates(const ir_ctx *ctx, ir_ref ref, ir_ref condition);
 
 /*** IR Live Info ***/
 typedef ir_ref                   ir_live_pos;
@@ -1468,9 +1473,7 @@
 void ir_fix_stack_frame(ir_ctx *ctx);
 
 /* Utility */
-ir_type ir_get_return_type(ir_ctx *ctx);
 const ir_proto_t *ir_call_proto(const ir_ctx *ctx, const ir_insn *insn);
-void ir_print_call_conv(uint32_t flags, FILE *f);
 
 //#define IR_BITSET_LIVENESS
 
diff '--color=auto' -Naur php-8.4.18/ext/opcache/jit/ir/ir_ra.c php-8.4.20RC1/ext/opcache/jit/ir/ir_ra.c
